Subject: Re: [bug#43581] [PATCH] guix build: Add '--without-tests'.
From: Ludovic Courtès <[email-masked]>
To: Jan Nieuwenhuizen <[email-masked]>
Cc: [email-masked]
Date: Sun, 27 Sep 2020 22:58:44 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

Jan Nieuwenhuizen <[email-masked]> skribis:

>> * guix/scripts/build.scm (transform-package-tests): New procedure.
>> (%transformations, %transformation-options)
>
> Nitpick, use comma                          ^
>
>> show-transformation-options-help): Add it.

Oops yes, and I forgot to fix it before pushing.  :-/

>> +Turning off tests leads to a different store item.  Consequently, when
>> +using this option, anything that depends on @var{package} must be
>> +rebuilt, as in this example:
>
> This makes sense, so I'm curious about it's usefulness in practice, but
> there have been several times during porting sessions where I have
> disabled tests by editing the package.

Yeah, that’s the typical use case.

> $ time ./pre-inst-env guix build automake --without-tests=automake --verbosity=1
> The following derivation will be built:
>    /gnu/store/0m9qp0rf74d6sray1ip6h050fzmrrya3-automake-1.16.2.drv
> building /gnu/store/0m9qp0rf74d6sray1ip6h050fzmrrya3-automake-1.16.2.drv...
> |offloading build of /gnu/store/0m9qp0rf74d6sray1ip6h050fzmrrya3-automake-1.16.2.drv to 'kluit.dezyne.org'
> /gnu/store/7qsz3avcfk6b6am0zj9ahsmjy8x6drxr-automake-1.16.2
>
> real	0m14.316s
> user	0m1.203s
> sys	0m0.072s

That’s also one of the packages I had in mind.  :-)

Ricardo Wurmus <[email-masked]> skribis:

> This looks good to me.  It’s much more convenient for the casual user
> than to clone the Guix repo and to edit the package definition there, or
> to extend the package collection with GUIX_PACKAGE_PATH or even a
> channel.

Yup.

> I suppose we’d have to fix all those packages that moved the check phase
> without also checking for the “#:tests?” keyword.  There are quite a few
> of those that thus wouldn’t be affected by “--without-tests”.

Right, hopefully there aren’t too many of those.

Pushed as f458cfbcc54ed87b1a87dd9e150ea276f17eab74, thanks!

Ludo’.